# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
import cmdlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

filters = ('#alive','#ct','#t')

slaytag     = '#greenSLAY'
slay_hudtag = 'SLAY'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load(): cmdlib.registerSayCommand('!slay', slayCMD,'SAM')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload(): cmdlib.unregisterSayCommand('!slay')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def slayCMD(userid, args):
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Slay'):
			if args:
				targets = len(args)
				admin   = playerlib.getPlayer(userid)
				if targets == 1:
					args   = ''.join(args)
					target = es.getuserid(args)
					if args not in filters:
						if es.exists('userid', target): moduleAction(admin, playerlib.getPlayer(target), 1)
						else: func.hudhint(userid, func.lang_pcontrol('target_not_exist', {'target':args}), slay_hudtag)
					else:
						plist   = playerlib.getPlayerList(args)
						targets = len(plist)
						for target in plist:
							if not target.isdead == True: target.slay()
							else: targets -= 1
						if targets > 0: func.tell('#human', func.lang_pcontrol('slay_multi_targets', {'num':targets}), slaytag)
				else:
					for x in args:
						if es.exists('userid', es.getuserid(x)):
							target = playerlib.getPlayer(es.getuserid(x))
							if admins.checkImmunity(admin.steamid, target.steamid):
								if not target.isdead == True: target.slay()
								else: targets -= 1
							else: targets -= 1
						else: targets -= 1
					if targets > 0: func.tell('#human', func.lang_pcontrol('slay_multi_targets', {'num':targets}), slaytag)
			else:
				block = es.import_addon('sam/base/pcontrol')
				block.function(userid, 'Slay', None)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(admin, target, rcmd = None):
	if target:
		if admins.checkImmunity(admin.steamid, target.steamid):
			if not target.isdead == True:
				target.slay()
				func.tell('#human', func.lang_pcontrol('slay_one_target', {'target':target.name}), slaytag)
			else: func.hudhint(admin, func.lang_pcontrol('slay_target_is_dead', {'target':target.name}), slay_hudtag)
		if rcmd == None:
			block = es.import_addon('sam/base/pcontrol')
			block.function(admin, 'Slay', None)

# ============================================================================================================================================================= #