# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
import time
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Clock'
addon.basename = 'clock'
addon.status   = 0
addon.version  = '1.0.p'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

line = '-' * 18

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### Run Clock ###
	clock()

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def clock():
	if int(es.ServerVar('sam_' + addon.basename)) == 1:
		func.keyhint('#all', '%s\n  %s\n%s\n  %s\n%s' % (line,time.strftime('%I:%M:%S %p'),line,time.strftime('%d/%m/%Y'),line))
		gamethread.delayed(0.50, clock, ())
	else: func.keyhint('#all', ' ')

# ============================================================================================================================================================= #
